/*******************************************************************************
 * FoxCustomizationNode_Receiver generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCustomizationNode_Receiver extends FoxCustomizationNode_Base within FoxArmoryUI
    config(UI);

struct native ReceiverInfo
{
    var class<FoxWeapon> WeaponClass;
    var FoxWeaponPresetInfo Preset;
    var FoxWeaponConfigInfo PresetConfig;

    structdefaultproperties
    {
        WeaponClass=none
        Preset=(Wpn="",Muz="",Sto="",Bar="",Mag="",Sco="",GRI="",Amm="",UnlockID=0,ParentID=0,NameID="",ImageIconRef="",NameLocSectionName="WeaponPresets",DescLocSectionName="WeaponPresetsDesc",TagLocSectionName="WeaponPresetsTag",TooltipLocSectionName="WeaponPresetsToolTip")
        PresetConfig=(WeaponSkin=255,WeaponClass=none,WeaponMuzzle=255,WeaponStock=none,WeaponBarrel=none,WeaponMagazine=255,WeaponScope=none,WeaponHanger=0,WeaponGrip=none,WeaponAmmo=none,WeaponCamoIndex=0)
    }
};

var transient array<ReceiverInfo> WeaponClasses;
var transient FoxWeaponConfigInfo EquippedWeaponConfig;
var int RolledOverIndex;

function Initialize(optional bool bSelectEquipped)
{
    local array<string> AllWeaponClassNames;
    local class<FoxWeapon> WeaponClass, CurrentWeaponClass;
    local int I;
    local ReceiverInfo NewReceiverInfo;
    local ScrollerListEntry NewScrollerListEntry;
    local FoxWeaponPresetInfo PresetForWeapon;
    local FoxWeaponConfigInfo NewPresetConfig;

    bSelectEquipped = true;
    super.Initialize(bSelectEquipped);
    // End:0x65
    if(bSelectEquipped)
    {
        Outer.CustomItemType = 1;
        Outer.ResetSelectedLoadout();
    }
    WeaponClasses.Length = 0;
    ScrollerEntries.Length = 0;
    Outer.SelectedScrollerIndex = 0;
    switch(Outer.SelectedCustomizationType)
    {
        // End:0x16C
        case 0:
            AllWeaponClassNames = Outer.LoadoutInfo.PrimaryWeaponNames;
            CurrentWeaponClass = Outer.SavedPrimaryWeaponInfo.WeaponClass;
            EquippedWeaponConfig = Outer.SavedPrimaryWeaponInfo;
            // End:0x216
            break;
        // End:0x213
        case 1:
            AllWeaponClassNames = Outer.LoadoutInfo.SecondaryWeaponNames;
            CurrentWeaponClass = Outer.SavedSecondaryWeaponInfo.WeaponClass;
            EquippedWeaponConfig = Outer.SavedSecondaryWeaponInfo;
            // End:0x216
            break;
        // End:0xFFFF
        default:
            I = 0;
            J0x221:
            // End:0x47F [Loop If]
            if(I < AllWeaponClassNames.Length)
            {
                WeaponClass = class<FoxWeapon>(Outer.LoadoutInfo.ResolveWpnContentByName(AllWeaponClassNames[I]));
                // End:0x471
                if((WeaponClass != none) && SetScrollerEntry(NewScrollerListEntry, WeaponClass.default.UnlockID))
                {
                    class'FoxUnlockInfo'.static.GetDefaultPresetForWeaponClass(WeaponClass, PresetForWeapon);
                    NewPresetConfig = Outer.LoadoutInfo.BuildWeaponConfigInfoFromPreset(PresetForWeapon);
                    NewReceiverInfo.WeaponClass = WeaponClass;
                    NewReceiverInfo.Preset = PresetForWeapon;
                    NewScrollerListEntry.InsertIndex = WeaponClasses.Length;
                    // End:0x40C
                    if(NewReceiverInfo.WeaponClass == CurrentWeaponClass)
                    {
                        SetEquipped(NewScrollerListEntry, bSelectEquipped);
                    }
                    AdjustPresetToCurrentConfig(NewPresetConfig);
                    NewReceiverInfo.PresetConfig = NewPresetConfig;
                    ScrollerEntries.AddItem(NewScrollerListEntry);
                    WeaponClasses.AddItem(NewReceiverInfo);
                }
                ++ I;
                // [Loop Continue]
                goto J0x221;
            }
            EquippedUnlockID = CurrentWeaponClass.default.UnlockID;
            SetupScrollerBar(bSelectEquipped);
            //return;
    }    
}

function AdjustPresetToCurrentConfig(out FoxWeaponConfigInfo DefaultWeaponConfig)
{
    // End:0xAF
    if((EquippedWeaponConfig.WeaponBarrel != none) && EquippedWeaponConfig.WeaponBarrel.static.IsValidForWeapon(DefaultWeaponConfig.WeaponClass, true))
    {
        DefaultWeaponConfig.WeaponBarrel = EquippedWeaponConfig.WeaponBarrel;
    }
    // End:0x15E
    if((EquippedWeaponConfig.WeaponGrip != none) && EquippedWeaponConfig.WeaponGrip.static.IsValidForWeapon(DefaultWeaponConfig.WeaponClass, true))
    {
        DefaultWeaponConfig.WeaponGrip = EquippedWeaponConfig.WeaponGrip;
    }
    // End:0x20D
    if((EquippedWeaponConfig.WeaponScope != none) && EquippedWeaponConfig.WeaponScope.static.IsValidForWeapon(DefaultWeaponConfig.WeaponClass, true))
    {
        DefaultWeaponConfig.WeaponScope = EquippedWeaponConfig.WeaponScope;
    }
    // End:0x2BC
    if((EquippedWeaponConfig.WeaponStock != none) && EquippedWeaponConfig.WeaponStock.static.IsValidForWeapon(DefaultWeaponConfig.WeaponClass, true))
    {
        DefaultWeaponConfig.WeaponStock = EquippedWeaponConfig.WeaponStock;
    }
    // End:0x36B
    if(EquippedWeaponConfig.WeaponClass == DefaultWeaponConfig.WeaponClass)
    {
        DefaultWeaponConfig.WeaponMagazine = EquippedWeaponConfig.WeaponMagazine;
        DefaultWeaponConfig.WeaponMuzzle = EquippedWeaponConfig.WeaponMuzzle;
    }
    // End:0x3E0
    if(DefaultWeaponConfig.WeaponClass.default.WeaponType == 0)
    {
        DefaultWeaponConfig.WeaponHanger = EquippedWeaponConfig.WeaponHanger;
    }
    DefaultWeaponConfig.WeaponCamoIndex = EquippedWeaponConfig.WeaponCamoIndex;
    //return;    
}

function ei_changeScrollerIndex(int NewIndex)
{
    Outer.UpdateCharacterLoadout(WeaponClasses[ScrollerEntries[NewIndex].InsertIndex].PresetConfig);
    // End:0xB5
    if(NewIndex != RolledOverIndex)
    {
        RolledOverIndex = NewIndex;
        Outer.ShowNodeSockets(NodeWidgetConfigs);
    }
    super.ei_changeScrollerIndex(NewIndex);
    //return;    
}

function ei_ScrollerClicked(string SelectedIndex)
{
    Outer.SelectedScrollerUnlock = ScrollerEntries[int(SelectedIndex)].UnlockID;
    super.ei_ScrollerClicked(SelectedIndex);
    //return;    
}

function NodeEquipButtonClicked(string SelectedIndex)
{
    local int NextIndex;

    NextIndex = int(SelectedIndex);
    switch(Outer.SelectedCustomizationType)
    {
        // End:0x121
        case 0:
            Outer.CachedPrimaryWeaponInfo = WeaponClasses[ScrollerEntries[NextIndex].InsertIndex].PresetConfig;
            Outer.SetModDataForWeapon(Outer.CachedPrimaryWeaponInfo, 1);
            Outer.UpdateCharacterLoadout(Outer.CachedPrimaryWeaponInfo);
            // End:0x208
            break;
        // End:0x205
        case 1:
            Outer.CachedSecondaryWeaponInfo = WeaponClasses[ScrollerEntries[NextIndex].InsertIndex].PresetConfig;
            Outer.SetModDataForWeapon(Outer.CachedSecondaryWeaponInfo, 1);
            Outer.UpdateCharacterLoadout(Outer.CachedSecondaryWeaponInfo);
            // End:0x208
            break;
        // End:0xFFFF
        default:
            Outer.ShowNodeSockets(NodeWidgetConfigs, NodeWidgetClickFunc);
            super.NodeEquipButtonClicked(SelectedIndex);
            //return;
    }    
}

function bool IsPurchased(int ItemId)
{
    return FoxServerConnection(Outer.Outer.Outer.PCOwner.WorldInfo.ServerConn).IsReceiverPurchased(ItemId, FoxPRI(Outer.Outer.Outer.PCOwner.PlayerReplicationInfo));
    //return ReturnValue;    
}

function UpdateNodeDetails()
{
    local array<Vector2D> NewStats;

    Outer.UpdateSelectedWeaponStats(NewStats);
    Outer.DisplayWeaponStats(NewStats);
    //return;    
}

function PrestreamIndex(int iIndex, bool bStreamIn)
{
    PrestreamMesh(SkeletalMeshComponent(WeaponClasses[ScrollerEntries[iIndex].InsertIndex].WeaponClass.default.Mesh).SkeletalMesh, bStreamIn);
    //return;    
}

defaultproperties
{
    EquippedWeaponConfig=(WeaponSkin=255,WeaponClass=none,WeaponMuzzle=255,WeaponStock=none,WeaponBarrel=none,WeaponMagazine=255,WeaponScope=none,WeaponHanger=0,WeaponGrip=none,WeaponAmmo=none,WeaponCamoIndex=0)
    RolledOverIndex=-1
    NodeWidgetConfigs(0)=(sLabel="Receiver",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Receiver,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(1)=(sLabel="Muzzle",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Muzzle,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(2)=(sLabel="Barrel",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Barrel,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(3)=(sLabel="Grip",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Grip,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(4)=(sLabel="Magazine",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Magazine,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(5)=(sLabel="Scope",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Scope,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(6)=(sLabel="Stock",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Stock,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(7)=(sLabel="Hanger",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_Hanger,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetConfigs(8)=(sLabel="Camo",SocketName=None,BoneName=None,FixedThresholdParam=0.0,bApplyThresholdLerp=false,bInvertAxis=false,WeaponModIndex=EWeaponCustomizationItem.ECI_WeaponCamo,GearIndex=EArmorItem.EAIT_Helmet)
    NodeWidgetClickFunc="ei_weaponNodeClicked"
    bComponentSlots=true
}